<?php

declare(strict_types=1);

namespace Drupal\graphql_compose\Plugin\GraphQLCompose\FieldType;

use Drupal\Core\Cache\RefinableCacheableDependencyInterface;
use Drupal\Core\Field\FieldItemInterface;
use Drupal\graphql_compose\Plugin\GraphQL\DataProducer\FieldProducerItemInterface;
use Drupal\graphql_compose\Plugin\GraphQL\DataProducer\FieldProducerTrait;
use Drupal\graphql_compose\Plugin\GraphQLCompose\GraphQLComposeFieldTypeBase;

/**
 * {@inheritDoc}
 *
 * @GraphQLComposeFieldType(
 *   id = "address",
 *   type_sdl = "Address",
 * )
 */
class AddressItem extends GraphQLComposeFieldTypeBase implements FieldProducerItemInterface {

  use FieldProducerTrait;

  /**
   * {@inheritdoc}
   */
  public function resolveFieldItem(FieldItemInterface $item, array $context, RefinableCacheableDependencyInterface $metadata) {

    return [
      'langcode'           => $item->langcode ?: NULL,
      'countryCode'        => $item->country_code ?: NULL,
      'givenName'          => $item->given_name ?: NULL,
      'additionalName'     => $item->additional_name ?: NULL,
      'familyName'         => $item->family_name ?: NULL,
      'organization'       => $item->organization ?: NULL,
      'addressLine1'       => $item->address_line1 ?: NULL,
      'addressLine2'       => $item->address_line2 ?: NULL,
      'postalCode'         => $item->postal_code ?: NULL,
      'sortingCode'        => $item->sorting_code ?: NULL,
      'dependentLocality'  => $item->dependent_locality ?: NULL,
      'locality'           => $item->locality ?: NULL,
      'administrativeArea' => $item->administrative_area ?: NULL,
    ];
  }

}
